<template>
  <st-content :heading="'Citas de ' + tutorship.nombre">
    <st-session-modal v-model="dialog" @refreshData="refresh" @cancel="closeRegisterModal" :key="componentKey"/>
    <div>
      <st-back-btn />
      <div class="content-body">
        <div class="table-heading">
          <st-search text="Buscar por nombre o código" @enter="searchInTable($event)"/>
          <st-primary-btn nombre="Registrar Cita" @click="open"/>
        </div>
        <st-data-table-popup
          @itemSelected="itemSelected"
          :dataInfo = "{ headers, items, key }"
          :loading = "loading"
          :search="searchQuery"/>
      </div>
    </div>
  </st-content>
</template>

<script>
  import Search from "../../../../components/Search";
  import DataTablePopup from "../../../../components/DataTablePopup";
  import {mapState} from "vuex";
  import TutorshipSessionModal from "../../../../components/TutorshipSessionModal";

  export default {
    data: () => ({
      componentKey: 0,
      key: 'idAlumno',
      searchQuery: '',
      dialog: false,
    }),
    components: {
      'st-search': Search,
      'st-data-table-popup': DataTablePopup,
      'st-session-modal': TutorshipSessionModal,
    },
    computed: {
      ...mapState('tutorships', {
        tutorship: (state) => state.tutoria,
        loading: (state) => state.loading,
        items: (state) => state.sesiones,
        headers: (state) => state.sessionsTableHeaders,
      }),
    },
    methods: {
      loadSessions(){
        const idTutorship = this.$route.params.id;
        if (!this.tutorship.idTutoria)
          this.$store.dispatch('tutorships/selectTutorship', {idTutorship: idTutorship});
        this.$store.dispatch('tutorships/searchSessions', {idTutorship: idTutorship});
      },
      itemSelected(item) {},
      registerAppointment() { this.dialog = true; },
      closeRegisterModal() { this.dialog = false; },
      searchInTable(value) { this.searchQuery = value; },
      refreshData() {
        this.loadSessions();
        // const idTutorship = this.$route.params.id;
        // this.$store.dispatch('tutorships/searchSessions', {idTutorship: idTutorship});
      },
      open(){
        this.dialog = true;
        this.componentKey += 1; //forceRerender
      },
      refresh(value){
        this.dialog = false;
        this.loadSessions();
      },
    },
    mounted() {
      this.loadSessions();
    }
  }
</script>


<style scoped lang="scss">
.elevation-1{
  margin:20px 0;
}
</style>
